/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_RAW_DNA_SEQUENCE_FORMAT_H_
#define _GB2_RAW_DNA_SEQUENCE_FORMAT_H_

#include <core_api/DocumentFormats.h>
#include <core_api/DocumentModel.h>

namespace GB2 {

class GB2_COREAPI_EXPORT RawDNASequenceFormat : public DocumentFormat {
    Q_OBJECT
public:
	RawDNASequenceFormat(QObject* p);

	virtual DocumentFormatId getFormatId() const {return BaseDocumentFormats::RAW_DNA_SEQUENCE;}

	virtual const QString& getFormatName() const {return formatName;}

	virtual QStringList getSupportedDocumentFileExtensions();

	virtual Document* loadExistingDocument(IOAdapterFactory* io, const QString& url, TaskStateInfo& ti, const QVariantMap& fs);

	virtual bool isDataFormatSupported(const char* data, int size) const;

	virtual bool isObjectOpSupported(const Document* d , DocumentFormat::DocObjectOp op, GObjectType t) const;

	virtual bool checkConstraints(const DocumentFormatConstraints& c) const;

    virtual int getFormatDetectionPriority() const {return -20;}

private:
	QString formatName;
};

}//namespace

#endif
