/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_SUBST_MATRIX_FACTORY_H_
#define _GB2_SUBST_MATRIX_FACTORY_H_

#include <util_smith_waterman/SubstMatrix.h>
#include <core_api/core_api.h>

namespace GB2 {

class GB2_COREAPI_EXPORT SubstMatrixFactory {
public:
	static SubstMatrix* createSubstMatrix(
							const QByteArray& mtxAlph, 
							const float* rawMatrix
						);
private:
	SubstMatrixFactory();
	static float getMin(const float* src, int len);
};

} // namespace

#endif
